import 'package:flutter/material.dart';
import 'package:flutter_slick/navigation/logic.dart';
import 'package:provider/provider.dart';

import 'application.dart';
import 'paths/root.dart';
import 'screens/initial.dart';
import 'services/mock_authentication.dart';

void main() {
  runApp(
    MultiProvider(
      providers: [
        Provider<MockAuthenticationService>(
          create: (context) {
            return MockAuthenticationService();
          },
        ),
        ChangeNotifierProvider<NavigationLogic>(
          create: (context) {
            return NavigationLogic(
              context: context,
              initialScreen: () => const InitialScreen(),
              rootPaths: rootPaths,
              authState:
                  Provider.of<MockAuthenticationService>(context, listen: false)
                      .authState,
            );
          },
        ),
      ],
      child: const Application(),
    ),
  );
}
