import 'package:flutter_slick/navigation/paths_builder.dart';
import 'package:flutter_slick/navigation/route_builder.dart';
import 'package:flutter_slick/navigation/route_path.dart';

import '../screens/not_found.dart';
import '../screens/index.dart';
import '../screens/sample.dart';

Future<RoutePath?> never(_, __) async => null;

PathsBuilder rootPaths = PathsBuilder(
  pattern: RegExp(r'^/(.*)$'),
  path: (path) => '/$path',
  notFoundScreen: () => const NotFoundScreen(),
  paths: [],
  builders: [
    RootPaths.index,
    RootPaths.sample,
  ],
);

class RootPaths {
  static final index = RouteBuilder(
    getBuilder: () => rootPaths,
    pattern: RegExp(r'^$'),
    parse: RouteArguments.parse,
    path: (_) => '',
    build: (_, __) async => const IndexScreen(),
    rewrite: never,
    menuItems: () => [],
  );

  static final sample = RouteBuilder(
    getBuilder: () => rootPaths,
    pattern: RegExp(r'^sample$'),
    parse: RouteArguments.parse,
    path: (_) => 'sample',
    build: (_, __) async => const SampleScreen(),
    rewrite: never,
    menuItems: () => [],
  );
}
