import 'dart:async';

import 'package:flutter_slick/services/authentication.dart';

import '../utils/auth_user.dart';

class MockAuthenticationService extends AuthenticationService<AuthUser> {
  final _authStateChangeController = StreamController<AuthUser?>.broadcast();
  final _tokenChangeController = StreamController<String?>.broadcast();

  AuthUser? _user;

  @override
  AuthUser? get user => _user;

  @override
  Stream<AuthUser?> get authState => _authStateChangeController.stream;

  @override
  Stream<String?> get tokenState => _tokenChangeController.stream;

  MockAuthenticationService() {
    Future.delayed(const Duration(seconds: 1))
        .then((value) => _authStateChangeController.add(AuthUser()));
  }

  @override
  Future<void> refreshToken(AuthUser user) async {}

  @override
  Future<void> signIn(String email, String password) async {
    _user = AuthUser();
    _authStateChangeController.add(_user);
  }

  @override
  Future<void> signOut() async {
    _user = null;
    _authStateChangeController.add(_user);
  }

  @override
  Future<void> createUser(String email, String password) async {}

  @override
  Future<void> resetPasswordReset(String email) async {}

  @override
  Future<void> confirmPasswordReset(String code, String newPassword) async {}

  @override
  Future<void> sendResetPasswordEmail(String? email) async {}

  @override
  Future<void> dispose() async {}
}
