import 'package:flutter/material.dart';

class PrimaryActionButton extends StatelessWidget {
  final IconData iconData;
  final String labelText;
  final void Function()? onPressed;

  const PrimaryActionButton({
    super.key,
    required this.iconData,
    required this.labelText,
    required this.onPressed,
  });

  @override
  Widget build(BuildContext context) {
    return FloatingActionButton.extended(
      icon: Icon(iconData),
      label: Text(labelText),
      onPressed: onPressed,
    );
  }
}
