import 'package:flutter/material.dart';

class SecondaryActionButton extends StatelessWidget {
  final IconData iconData;
  final String labelText;
  final void Function() onPressed;

  const SecondaryActionButton({
    super.key,
    required this.iconData,
    required this.labelText,
    required this.onPressed,
  });

  @override
  Widget build(BuildContext context) {
    return FloatingActionButton.extended(
      foregroundColor: Theme.of(context).primaryColor,
      backgroundColor: Colors.white,
      icon: Icon(iconData),
      label: Text(labelText),
      onPressed: onPressed,
    );
  }
}
