import 'package:flutter/material.dart';

class SpacedRow extends StatelessWidget {
  final MainAxisSize mainAxisSize;
  final MainAxisAlignment mainAxisAlignment;
  final CrossAxisAlignment crossAxisAlignment;
  final double spaceSize;
  final List<Widget> children;

  const SpacedRow({
    Key? key,
    this.mainAxisSize = MainAxisSize.max,
    this.mainAxisAlignment = MainAxisAlignment.start,
    this.crossAxisAlignment = CrossAxisAlignment.center,
    this.spaceSize = 16.0,
    required this.children,
  }) : super(key: key);

  List<Widget> get _spacedChildren {
    var result = <Widget>[];
    for (var child in children) {
      result.add(child);
      if (children.last != child) {
        result.add(SizedBox(width: spaceSize));
      }
    }
    return result;
  }

  @override
  Widget build(BuildContext context) {
    return Row(
      mainAxisSize: mainAxisSize,
      mainAxisAlignment: mainAxisAlignment,
      crossAxisAlignment: crossAxisAlignment,
      children: _spacedChildren,
    );
  }
}
