import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

import '../../navigation/logic.dart';
import '../../navigation/route_path.dart';
import '../../utils/format.dart';

class LinkText extends StatelessWidget {
  final String? data;
  final RoutePath routePath;

  const LinkText(
    this.data,
    this.routePath, {
    Key? key,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    if (data == null) {
      return _buildText();
    } else {
      return InkWell(
        onTap: () {
          var navigation = Provider.of<NavigationLogic>(context, listen: false);
          navigation.setRoutePath(routePath);
        },
        child: _buildText(),
      );
    }
  }

  Widget _buildText() {
    return Text(
      formatNullable(data),
    );
  }
}
