import 'package:flutter/material.dart';
import 'route_path.dart';
import 'route_builder.dart';

class NavigationItem {
  final String labelText;
  final IconData? iconData;
  final RoutePath<RouteArguments>? routePath;
  final List<NavigationItem>? children;

  NavigationItem({
    required this.labelText,
    this.routePath,
    this.iconData,
    this.children,
  }) : assert(
            routePath == null && children != null ||
                routePath != null && children == null,
            'A NavigationItem requires a routePath or children. It also cannot have both.');
}
