import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:mockito/mockito.dart';

import 'package:flutter_slick/navigation/route_builder.dart';
import 'package:flutter_slick/navigation/paths_builder.dart';

class MockBuildContext extends Mock implements BuildContext {}

void main() {
  test('build minimal route', () async {
    var pathsBuilder = PathsBuilder(
      pattern: RegExp(r''),
      path: (_) => '',
      notFoundScreen: () => const Text(''),
      paths: [],
      builders: [],
    );
    var routeBuilder = RouteBuilder(
      getBuilder: () => pathsBuilder,
      pattern: RegExp(r''),
      parse: (_, __) => RouteArguments(),
      path: (_) => '',
      build: (_, __) async => const Text('Test'),
      rewrite: (_, __) async => null,
    );
    var routePath = routeBuilder({}, {});
    assert(routePath.path == '');
    var context = MockBuildContext();
    var result = await routePath.build(context) as Text;
    assert(result.data == 'Test');
  });
}
